Bug 1027600 - [RFE][rmmod] if module is in used, rmmod output the dependences
[RFE][rmmod] if module is in used, rmmod output the dependences
Status: CLOSED CANTFIX
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: kmod (Show other bugs)
7.0
All Linux
unspecified Severity medium
: rc
: ---
Assigned To: Václav Pavlín
Red Hat Kernel QE team
: FutureFeature
Depends On:
Blocks: 1027601
  Show dependency treegraph
 
Reported: 2013-11-07 03:09 EST by Yin.JianHong
Modified: 2013-12-16 10:15 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
: 1027601 (view as bug list)
Environment:
Last Closed: 2013-12-16 10:15:40 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Yin.JianHong 2013-11-07 03:09:50 EST
Description of problem:
When we want rmmod the nfsd, the rmmod just tell me module "is in use".
  But not tell me who use it.
[root@dhcp12-144 ~]# rmmod nfsd
rmmod: ERROR: Module nfsd is in use   <<<--- NOT GOOD
[root@dhcp12-144 ~]# rmmod auth_rpcgss
rmmod: ERROR: Module auth_rpcgss is in use by: nfsd   <<<--- GOOD

And my buddy cost more than half an hours to find why can not rmmod,
  Finally we find it used by /proc/fs/nfsd.
Could rmmod output the dependences, if the dependences is not module name?

Version-Release number of selected component (if applicable):
all version in RHEL{5,6,7}

How reproducible:
100%

Steps to Reproduce:
1. rmmod nfsd
2.
3.

Actual results:
[root@dhcp12-144 ~]# rmmod nfsd
rmmod: ERROR: Module nfsd is in use 

Expected results:
[root@dhcp12-144 ~]# rmmod nfsd
rmmod: ERROR: Module nfsd is in use "by: /proc/fs/nfsd"
OR like follow (if difficult to get):
rmmod: ERROR: Module nfsd is in use "by: nil(maybe used by special filesystem)"

Additional info:
Comment 2 Václav Pavlín 2013-12-12 04:16:05 EST
I am afraid this is not possible. As rmmod can only get the idea whether the module is used or not from refcnt (/sys/module/nfsd/refcnt), which is set by kernel, I don't see any option how to get the information what is actually using the module.

CC'ing Josh Boyer for his opinion.
Comment 3 Josh Boyer 2013-12-12 09:02:12 EST
I agree with Václav.  The only things rmmod/modprobe have to look at are the refcnt and the module dependency list (holders).  If a module has its refcnt incremented by something other than another module, there is no simple way for rmmod/modprobe -r to determine that.
Comment 4 Václav Pavlín 2013-12-16 10:15:40 EST
So closing as CANTFIX.

Note You need to log in before you can comment on or make changes to this bug.